Paul Duffin | 064b70c | 2020-11-02 17:32:38 +0000 | [diff] [blame^] | 1 | #!/bin/bash |
| 2 | |
| 3 | set -eu |
| 4 | |
| 5 | # Copyright 2020 Google Inc. All rights reserved. |
| 6 | # |
| 7 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 8 | # you may not use this file except in compliance with the License. |
| 9 | # You may obtain a copy of the License at |
| 10 | # |
| 11 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 12 | # |
| 13 | # Unless required by applicable law or agreed to in writing, software |
| 14 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 15 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 16 | # See the License for the specific language governing permissions and |
| 17 | # limitations under the License. |
| 18 | |
| 19 | # Tool to unpack an apex file and verify that the required files were extracted. |
| 20 | if [ $# -lt 5 ]; then |
| 21 | echo "usage: $0 <deapaxer_path> <debugfs_path> <apex file> <output_dir> <required_files>+" >&2 |
| 22 | exit 1 |
| 23 | fi |
| 24 | |
| 25 | DEAPEXER_PATH=$1 |
| 26 | DEBUGFS_PATH=$2 |
| 27 | APEX_FILE=$3 |
| 28 | OUTPUT_DIR=$4 |
| 29 | shift 4 |
| 30 | REQUIRED_PATHS=$@ |
| 31 | |
| 32 | set -x 1 |
| 33 | |
| 34 | rm -fr $OUTPUT_DIR |
| 35 | mkdir -p $OUTPUT_DIR |
| 36 | |
| 37 | # Unpack the apex file contents. |
| 38 | $DEAPEXER_PATH --debugfs_path $DEBUGFS_PATH extract $APEX_FILE $OUTPUT_DIR |
| 39 | |
| 40 | # Verify that the files that the build expects to be in the .apex file actually |
| 41 | # exist, and make sure they have a fresh mtime to not confuse ninja. |
| 42 | typeset -i FAILED=0 |
| 43 | for r in $REQUIRED_PATHS; do |
| 44 | if [ ! -f $r ]; then |
| 45 | echo "Required file $r not present in apex $APEX_FILE" >&2 |
| 46 | FAILED=$FAILED+1 |
| 47 | else |
| 48 | # TODO(http:/b/177646343) - deapexer extracts the files with a timestamp of 1 Jan 1970. |
| 49 | # touch the file so that ninja knows it has changed. |
| 50 | touch $r |
| 51 | fi |
| 52 | done |
| 53 | |
| 54 | if [ $FAILED -gt 0 ]; then |
| 55 | echo "$FAILED required files were missing from $APEX_FILE" >&2 |
| 56 | echo "Available files are:" >&2 |
| 57 | find $OUTPUT_DIR -type f | sed "s|^| |" >&2 |
| 58 | exit 1 |
| 59 | fi |